/* Jentchina - CnlFiltersTree
 * STRASSER Michel - 20040317		init
 * */

#ifndef __JNA_CNL_FILTERS_TREE_H__
#define __JNA_CNL_FILTERS_TREE_H__

#include <glib.h>
#include <glib-object.h>
#include "JnaCnlIter.h"


#define	JNA_TYPE_CNL_FILTERS_TREE			(JnaCnlFiltersTree_getType ())
#define JNA_CNL_FILTERS_TREE(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_CNL_FILTERS_TREE, JnaCnlFiltersTree))
#define JNA_CNL_FILTERS_TREE_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_CNL_FILTERS_TREE, JnaCnlFiltersTreeClass))
#define JNA_IS_CNL_FILTERS_TREE(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_CNL_FILTERS_TREE))
#define JNA_IS_CNL_FILTERS_TREE_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_CNL_FILTERS_TREE))
#define JNA_CNL_FILTERS_TREE_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_CNL_FILTERS_TREE_TYPE_NAME(object)	  (g_type_name (JNA_CNL_FILTERS_TREE_TYPE (object)))

typedef struct _JnaCnlFiltersTree	JnaCnlFiltersTree;
typedef struct _JnaCnlFiltersTreeClass	JnaCnlFiltersTreeClass;
typedef struct _JnaCnlFiltersTreeServer	JnaCnlFiltersTreeServer;

typedef enum {
	JnaCnlFiltersType__IMPORT,
	JnaCnlFiltersType__EXPORT
} JnaCnlFiltersType;

struct _JnaCnlFiltersTree
{
	GObject 		parent_instance;
	JnaCnlFiltersType 	filtersType;
	GObject*		first;		/* JnaCnlServerFiltersTree */
	GObject*		last;		/* JnaCnlServerFiltersTree */
	int			nServers;
};

struct _JnaCnlFiltersTreeClass
{
	GObjectClass 		parent_class;
};

G_BEGIN_DECLS

GType		
JnaCnlFiltersTree_getType		(void);


GObject* 	
JnaCnlFiltersTree_new			(JnaCnlFiltersType filtersType);

void 
JnaCnlFiltersTree_print			(JnaCnlFiltersTree* self);

void 
JnaCnlFiltersTree_merge			(JnaCnlFiltersTree* self,
					 GObject* xServer,	/* JnaXServerInfoReader */
					 GObject* xTree);	/* JnaXFiltersTreeReader */

char* /* newly allocated */
JnaCnlFiltersTree_getFilterPath		(JnaCnlFiltersTree* self,
					 JnaCnlIter iter);

gboolean
JnaCnlFiltersTree_getServerInfos	(JnaCnlFiltersTree* self,
					 JnaCnlIter iter,
					 char** out_domain,	/* newly allocated */
					 char** out_id);	/* newly allocated */


int /* You may need to cast */
JnaCnlFiltersTree_getData		(JnaCnlFiltersTree* self,
					 JnaCnlIter iter);

void
JnaCnlFiltersTree_setData		(JnaCnlFiltersTree* self,
					 JnaCnlIter iter,
					 int data); /* you may need to cast */


G_END_DECLS

#endif /* __JNA_CNL_FILTERS_TREE_H__ */
