#include "JnaCnlIter.h"

JnaCnlIter
JnaCnlIter_new				(int filterType,
					 int server,
					 int nodeNumber)
{
	JnaCnlIter retval;

	g_return_val_if_fail(filterType<=1 && filterType>=0, 0);
	g_return_val_if_fail(server<=0x7fff && server>=0, 0);
	g_return_val_if_fail(nodeNumber<=0x7fff && nodeNumber>=0, 0);
	
	retval=0;
	filterType=filterType&0x1;
	retval=filterType;
	retval=retval<<15;
	server=server&0x7fff;
	retval=retval|server;
	retval=retval<<15;
	nodeNumber=nodeNumber&0x7fff;
	retval=retval|nodeNumber;
	retval=retval<<1;
	retval=retval|1;
	
	return retval;
}

gboolean
JnaCnlIter_isValid			(JnaCnlIter self)
{
	if(self&1)
		return TRUE;
	else {
		g_critical("iter '%u' not valid", self);
		return FALSE;
	}
}

int
JnaCnlIter_getFilterType		(JnaCnlIter self)
{
	g_return_val_if_fail(JnaCnlIter_isValid(self), 0);

	return self>>31;
}

int
JnaCnlIter_getServerNumber		(JnaCnlIter self)
{
	g_return_val_if_fail(JnaCnlIter_isValid(self), 0);
	
	return (self>>16)&0x7fff;
}

int
JnaCnlIter_getNodeNumber		(JnaCnlIter self)
{
	g_return_val_if_fail(JnaCnlIter_isValid(self), 0);

	return (self>>1)&0x7fff;
}

void
JnaCnlIter_getAllFast			(JnaCnlIter self,
					 int* filterType,
					 int* serverNumber,
					 int* nodeNumber)
{
	g_return_if_fail(JnaCnlIter_isValid(self));

	*filterType=JnaCnlIter_getFilterType(self);
	*serverNumber=JnaCnlIter_getServerNumber(self);
	*nodeNumber=JnaCnlIter_getNodeNumber(self);
}


void
JnaCnlIter_print			(JnaCnlIter self)
{
	g_return_if_fail(JnaCnlIter_isValid(self));

	g_print("Jna::Central::Iter (%d, %d, %d')\n",
		JnaCnlIter_getFilterType(self),
		JnaCnlIter_getServerNumber(self),
		JnaCnlIter_getNodeNumber(self));
}


