/* Jentchina - CnlServerFiltersTree
 * STRASSER Michel - 20040403		init
 * */

#ifndef __JNA_CNL_SERVER_FILTERS_TREE_H__
#define __JNA_CNL_SERVER_FILTERS_TREE_H__

#include <glib.h>
#include <glib-object.h>
#include "JnaCnlIter.h"

#define	JNA_TYPE_CNL_SERVER_FILTERS_TREE			(JnaCnlServerFiltersTree_getType ())
#define JNA_CNL_SERVER_FILTERS_TREE(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_CNL_SERVER_FILTERS_TREE, JnaCnlServerFiltersTree))
#define JNA_CNL_SERVER_FILTERS_TREE_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_CNL_SERVER_FILTERS_TREE, JnaCnlServerFiltersTreeClass))
#define JNA_IS_CNL_SERVER_FILTERS_TREE(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_CNL_SERVER_FILTERS_TREE))
#define JNA_IS_CNL_SERVER_FILTERS_TREE_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_CNL_SERVER_FILTERS_TREE))
#define JNA_CNL_SERVER_FILTERS_TREE_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_CNL_SERVER_FILTERS_TREE_TYPE_NAME(object)	  (g_type_name (JNA_CNL_SERVER_FILTERS_TREE_TYPE (object)))

typedef struct _JnaCnlServerFiltersTree	JnaCnlServerFiltersTree;
typedef struct _JnaCnlServerFiltersTreeClass	JnaCnlServerFiltersTreeClass;
typedef struct _JnaCnlServerFiltersTreeServer	JnaCnlServerFiltersTreeServer;
typedef struct _JnaCnlFilter		JnaCnlFilter;

struct _JnaCnlFilter
{
	char* 			name;
	int			parent;
	int			next;
	int 			child;
	int			data;
};

struct _JnaCnlServerFiltersTree
{
	GObject 		parent_instance;
	
	/* BEGIN relatively of the other servers */
	GObject*		previous;	/* JnaCnlServerFiltersTree (or NULL if none) */
	GObject*		next;		/* JnaCnlServerFiltersTree (or NULL if none) */
	int			num;
	GObject*		server;		/* JnaXServerInfoReader */
	/* END relatively of the other servers */

	/* BEGIN contains */
	JnaCnlFilter*		array;
	int 			alreadyUsed;
	int 			max;
	/* END contains */
};

struct _JnaCnlServerFiltersTreeClass
{
	GObjectClass 		parent_class;
};

G_BEGIN_DECLS

GType		
JnaCnlServerFiltersTree_getType		(void);


GObject* 	
JnaCnlServerFiltersTree_new			(GObject* xServer,	/* JnaXServerInfoReader */
						 GObject* xTree,	/* JnaXFiltersTreeReader */
						 int num,
						 GObject* previous);	/* JnaCnlServerFiltersTree */

void 
JnaCnlServerFiltersTree_print			(JnaCnlServerFiltersTree* self);

int
JnaCnlServerFiltersTree_getData			(JnaCnlServerFiltersTree* self,
						 JnaCnlIter iter);

void
JnaCnlServerFiltersTree_setData			(JnaCnlServerFiltersTree* self,
						 JnaCnlIter iter,
						 int data);

void
JnaCnlServerFiltersTree_getServerInfo		(JnaCnlServerFiltersTree* self,
						 char** out_domain,
						 char** out_id,
						 char** out_name);
		
#if 0
int	
JnaCnlServerFiltersTree_insert			(JnaCnlServerFiltersTree* self,
						 int parent, 	/* 0 if none */
						 int sibling,	/* 0 if none */
						 char* name);	/* node name */

#endif

G_END_DECLS

#endif /* __JNA_CNL_SERVER_FILTERS_TREE_H__ */
