/* Jentchina -CnlStream
 * STRASSER Michel - 20040206		init
 * */


#include "JnaCnlStream.h"
#include <glib.h>
#include <glib-object.h>
#include <stdio.h>

static GObjectClass *jnaCnlStream_parentClass;

static void
impl_JnaCnlStream_finalize(GObject *object)
{
	JnaCnlStream *self=(JnaCnlStream*)object;

	g_free(self->seq);
	jnaCnlStream_parentClass->finalize(object);
}

static void
JnaCnlStreamClass_init (JnaCnlStreamClass *selfClass)
{
	GObjectClass *objectClass = (GObjectClass *)selfClass;
	jnaCnlStream_parentClass = g_type_class_peek_parent (selfClass);

	objectClass->finalize=impl_JnaCnlStream_finalize;
}

GType		JnaCnlStream_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (JnaCnlStreamClass),
			NULL, NULL,
			(GClassInitFunc) JnaCnlStreamClass_init,
			NULL, NULL,
			sizeof (JnaCnlStream),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			G_TYPE_OBJECT,
			"JnaCnlStream", &info, 0);
	}

	return type;
}

GObject* 	
JnaCnlStream_new		(unsigned char* seq,	
				 unsigned int length)
{
	JnaCnlStream* retval;

	g_return_val_if_fail(length, NULL);
	
	retval=g_object_new(JNA_TYPE_CNL_STREAM, NULL);
	
	retval->seq=g_memdup((gconstpointer)seq, (guint)length + 1);
	retval->seq[length]=0;	/* put a 0 at the end for convenience */
	retval->length=length;

	return (GObject*) retval;
}

gboolean /* returns FALSE if there was an error */
JnaCnlStream_writeIntoFile	(JnaCnlStream*	self,
				 char* file)
{
	gboolean retval=TRUE;
	FILE* fd;

	fd=fopen(file, "w");
	fwrite(self->seq, 1, self->length, fd);
	fclose(fd);

	return retval;
}


