/* Jentchina - Communication sub system
 * STRASSER Michel - 20040131		init
 * */


#include "JnaCom.h"
#include <glib.h>
#include <glib-object.h>

#define VIRTUAL_FUNC \
	g_critical("function %s should be overriden", __PRETTY_FUNCTION__ ); \
	return NULL;

/* returns a JnaComRendezVous object*/
GObject*
impl_JnaCom_getRendezVous	(JnaCom* self,
				 JnaComFilterType filterType,
				 char* filterName,
				 char* user,
				 char* password,
				 GObject* lsmStream,
				 GObject** out_comException)
{
	VIRTUAL_FUNC
}


/* returns a JnaStream, that contains a lsmStream */
GObject*
impl_JnaCom_applyFilter		(JnaCom* self,
				 char* sessionKey,
				 GObject* interfacesStream,
				 GObject** out_comException)
{
	VIRTUAL_FUNC
}

/* returns a JnaStream, that contains a PNG picture, an xml stream, etc ...  */
GObject*
impl_JnaCom_getRessource	(JnaCom* self,
				 char* ressourcePath,
				 GObject** out_comException)
{
	VIRTUAL_FUNC
}

static void
JnaComClass_init (JnaComClass *selfClass)
{
	selfClass->getRendezVous=impl_JnaCom_getRendezVous;
	selfClass->applyFilter=impl_JnaCom_applyFilter;
	selfClass->getRessource=impl_JnaCom_getRessource;
}

GType		JnaCom_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (JnaComClass),
			NULL, NULL,
			(GClassInitFunc) JnaComClass_init,
			NULL, NULL,
			sizeof (JnaCom),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			G_TYPE_OBJECT,
			"JnaCom", &info, G_TYPE_FLAG_ABSTRACT);
	}

	return type;
}

/* returns a JnaComRendezVous object*/
GObject*
JnaCom_getRendezVous		(JnaCom* self,
				 JnaComFilterType filterType,
				 char* filterName,
				 char* user,
				 char* password,
				 GObject* lsmStream,
				 GObject** out_comException)
{
	g_return_val_if_fail(JNA_IS_COM(self), NULL);

	return JNA_COM_CLASS(G_OBJECT_GET_CLASS(self))->getRendezVous(self, filterType, filterName,
			user, password, lsmStream, out_comException);
}


/* returns a JnaStream, that contains a lsmStream */
GObject*
JnaCom_applyFilter		(JnaCom* self,
				 char* sessionKey,
				 GObject* interfacesStream,
				 GObject** out_comException)
{
	g_return_val_if_fail(JNA_IS_COM(self), NULL);

	return JNA_COM_CLASS(G_OBJECT_GET_CLASS(self))->applyFilter(self, sessionKey,
			interfacesStream, out_comException);
}

/* returns a JnaStream, that contains a PNG picture, an xml stream, etc ...  */
GObject*
JnaCom_getRessource		(JnaCom* self,
				 char* ressourcePath,
				 GObject** out_comException)
{
	g_return_val_if_fail(JNA_IS_COM(self), NULL);

	return JNA_COM_CLASS(G_OBJECT_GET_CLASS(self))->getRessource(self, ressourcePath, out_comException);
}
