/* Jentchina - Communication sub system - Com factory
 * STRASSER Michel - 20040305		init
 * */


#include "JnaComFactory.h"
#include <glib.h>
#include <glib-object.h>
#include "ComCorba/JnaComCorba.h"
#include "../XmlReaders/pack_XmlReaders.h"

static GObjectClass *jnaComFactory_parentClass;

static void
impl_JnaComFactory_finalize(GObject* selfO)
{
	JnaComFactory* self=(JnaComFactory*)selfO;

	g_hash_table_destroy(self->comConstructors);

	jnaComFactory_parentClass->finalize(selfO);
}

static void
JnaComFactoryClass_init (JnaComFactoryClass *selfClass)
{
	GObjectClass *objectClass = (GObjectClass *)selfClass;

	jnaComFactory_parentClass = g_type_class_peek_parent (selfClass);

	objectClass->finalize=impl_JnaComFactory_finalize;
}

GType		JnaComFactory_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (JnaComFactoryClass),
			NULL, NULL,
			(GClassInitFunc) JnaComFactoryClass_init,
			NULL, NULL,
			sizeof (JnaComFactory),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			G_TYPE_OBJECT,
			"JnaComFactory", &info, 0);
	}

	return type;
}

GObject* 	
JnaComFactory_new			(char* sessionKey,
					 GList* interfacesList,	
					 int vortexLifeTime)
{
	JnaComFactory* retval;
	static char corbaStr[]="CORBA";
	
	retval=g_object_new(JNA_TYPE_COM_FACTORY, NULL);
	
	retval->comConstructors=g_hash_table_new(g_str_hash, g_str_equal);
	g_hash_table_insert(retval->comConstructors, corbaStr, JnaComCorba_new); 

	return (GObject*) retval;
}

GObject*
JnaComFactory_getNewCom			(JnaComFactory* self,
					 char* strategy,
					 char* opt)
{
	GObject* retval;
	JnaComFactoryComConstructor c=NULL;
	
	g_return_val_if_fail(JNA_IS_COM_FACTORY(self), NULL);
	g_return_val_if_fail(strategy, NULL);
	g_return_val_if_fail(opt, NULL);
	c=g_hash_table_lookup(self->comConstructors, strategy);
	g_return_val_if_fail(c, NULL);
	retval=c(opt);
	g_return_val_if_fail(retval, NULL);
	
	return retval;
}

GObject*
JnaComFactory_getNewComFromXServer	(JnaComFactory* self,
					 GObject* xServer)
{
	GObject* retval;
	JnaComFactoryComConstructor c=NULL;
	
	g_return_val_if_fail(JNA_IS_COM_FACTORY(self), NULL);
	g_return_val_if_fail(JNA_IS_X_SERVER(xServer), NULL);
	
	c=g_hash_table_lookup(self->comConstructors, JNA_X_SERVER(xServer)->strategy);
	g_return_val_if_fail(c, NULL);
	retval=c(JNA_X_SERVER(xServer)->opt);
	g_return_val_if_fail(retval, NULL);
	
	return retval;

}


