/* Jentchina - Communication sub system
 * STRASSER Michel - 20040131		init
 * */


#include "JnaComRendezVous.h"
#include <glib.h>
#include <glib-object.h>

static GObjectClass *jnaComRendezVous_parentClass;

static void
impl_JnaComRendezVous_finalize(GObject* selfO)
{
	GList* l;
	JnaComRendezVous* self=(JnaComRendezVous*)selfO;

	for(l=self->interfacesList ; l ; l=g_list_next(l))
		g_free(l->data);

	g_list_free(self->interfacesList);
	g_free(self->sessionKey);
	
	jnaComRendezVous_parentClass->finalize(selfO);
}

static void
JnaComRendezVousClass_init (JnaComRendezVousClass *selfClass)
{
	GObjectClass *objectClass = (GObjectClass *)selfClass;

	jnaComRendezVous_parentClass = g_type_class_peek_parent (selfClass);

	objectClass->finalize=impl_JnaComRendezVous_finalize;
}

GType		JnaComRendezVous_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (JnaComRendezVousClass),
			NULL, NULL,
			(GClassInitFunc) JnaComRendezVousClass_init,
			NULL, NULL,
			sizeof (JnaComRendezVous),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			G_TYPE_OBJECT,
			"JnaComRendezVous", &info, 0);
	}

	return type;
}

GObject* 	
JnaComRendezVous_new			(char* sessionKey,
					 GList* interfacesList,	
					 int vortexLifeTime)
{
	JnaComRendezVous* retval;
	
	retval=g_object_new(JNA_TYPE_COM_RENDEZ_VOUS, NULL);
	
	retval->sessionKey=g_strdup(sessionKey);
	retval->interfacesList=interfacesList;
	retval->vortexLifeTime=vortexLifeTime;
	/* TODO */
	retval->creationTime=0;

	return (GObject*) retval;
}

gboolean
JnaComRendezVous_isVortexClosed		(JnaComRendezVous* self)
{
	gboolean retval=FALSE;
	
	g_return_val_if_fail(JNA_IS_COM_RENDEZ_VOUS(self), retval);
	
	/* TODO */
	g_message("JnaComRendezVous_isVortexClosed has not been implemented yet");

	return retval;
}

