/* Jentchina -XAuthorInfoReader
 * STRASSER Michel - 20040206		init
 * */

#include "JnaXAuthorInfoReader.h"
#include "JnaXCommon.h"
#include <glib.h>
#include <glib-object.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include <libxml/xpath.h>
#include <string.h>

static GObjectClass *jnaXAuthorInfoReader_parentClass;

static void
impl_JnaXAuthorInfoReader_finalize(GObject *object)
{
	JnaXAuthorInfoReader *self=(JnaXAuthorInfoReader*)object;

	g_free(self->id);
	g_free(self->name);
	g_free(self->email);
	
	jnaXAuthorInfoReader_parentClass->finalize(object);
}

static void
JnaXAuthorInfoReaderClass_init (JnaXAuthorInfoReaderClass *selfClass)
{
	GObjectClass *objectClass = (GObjectClass *)selfClass;
	jnaXAuthorInfoReader_parentClass = g_type_class_peek_parent (selfClass);

	objectClass->finalize=impl_JnaXAuthorInfoReader_finalize;
}

char*
JnaXAuthorInfoReader_toString		(JnaXAuthorInfoReader* self)
{
	char* retval;
	
	g_return_val_if_fail(JNA_IS_X_AUTHOR_INFO_READER(self), NULL);
	retval=g_strdup_printf("Jna::XmlReaders::AuthorInfoReader .id='%s' .name='%s' .email='%s'\n", 
			self->id, 
			self->name,
			self->email);

	return retval;
}

void
JnaXAuthorInfoReader_print		(JnaXAuthorInfoReader* self)
{
	char* str;
	
	g_return_if_fail(JNA_IS_X_AUTHOR_INFO_READER(self));
	
	str=JnaXAuthorInfoReader_toString(self);
	g_print(str);
	g_free(str);
}

GType		JnaXAuthorInfoReader_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (JnaXAuthorInfoReaderClass),
			NULL, NULL,
			(GClassInitFunc) JnaXAuthorInfoReaderClass_init,
			NULL, NULL,
			sizeof (JnaXAuthorInfoReader),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			G_TYPE_OBJECT,
			"JnaXAuthorInfoReader", &info, 0);
	}

	return type;
}

GObject* 	
JnaXAuthorInfoReader_new			(char* xmlFile)
{
	JnaXAuthorInfoReader* retval;
	xmlDocPtr doc;
	xmlXPathContextPtr xpath_context;
	xmlXPathObjectPtr xpath_object=NULL;
	xmlNodePtr node;
	int max;

	g_return_val_if_fail(xmlFile, NULL);
	
	doc=xmlParseFile(xmlFile);

	if(!doc) {
		g_critical("File %s is not a valid xml file", xmlFile);
		return NULL;
	}

	retval=g_object_new(JNA_TYPE_X_AUTHOR_INFO_READER, NULL);

	retval->id=JnaXCommon_getRadical(xmlFile);
	g_return_val_if_fail(retval->id, NULL);

	xpath_context = xmlXPathNewContext (doc);

	xpath_object = xmlXPathEval ("/TblAi/TblAiName", xpath_context);
	max=xmlXPathNodeSetGetLength(xpath_object->nodesetval);
	g_return_val_if_fail(max>0, NULL);
	node=xmlXPathNodeSetItem(xpath_object->nodesetval, 0);
	retval->name=g_strdup((char *) xmlNodeGetContent(node));
	xmlXPathFreeObject(xpath_object);
	
	xpath_object = xmlXPathEval ("/TblAi/TblAiEmail", xpath_context);
	max=xmlXPathNodeSetGetLength(xpath_object->nodesetval);
	g_return_val_if_fail(max>0, NULL);
	node=xmlXPathNodeSetItem(xpath_object->nodesetval, 0);
	retval->email=g_strdup((char *) xmlNodeGetContent(node));
	xmlXPathFreeObject(xpath_object);

	xmlXPathFreeContext(xpath_context);
	xmlFreeDoc(doc);

	return (GObject*) retval;
}


