/* Jentchina -XServer
 * STRASSER Michel - 20040206		init
 * */


#include "JnaXServer.h"
#include <glib.h>
#include <glib-object.h>

static GObjectClass *jnaXServer_parentClass;

static void
impl_JnaXServer_finalize(GObject *object)
{
	JnaXServer *self=(JnaXServer*)object;

	g_free(self->strategy);
	g_free(self->opt);
	jnaXServer_parentClass->finalize(object);
}

static void
JnaXServerClass_init (JnaXServerClass *selfClass)
{
	GObjectClass *objectClass = (GObjectClass *)selfClass;
	jnaXServer_parentClass = g_type_class_peek_parent (selfClass);

	objectClass->finalize=impl_JnaXServer_finalize;
}

char*
JnaXServer_toString		(JnaXServer* self)
{
	char* retval;
	
	g_return_val_if_fail(JNA_IS_X_SERVER(self), NULL);
	retval=g_strdup_printf("Jna::XmlReaders::XServer .strategy='%s' .opt='%s'\n", self->strategy, self->opt);

	return retval;
}

void
JnaXServer_print		(JnaXServer* self)
{
	char* str;
	
	g_return_if_fail(JNA_IS_X_SERVER(self));
	
	str=JnaXServer_toString(self);
	g_print(str);
	g_free(str);
}

GType		JnaXServer_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (JnaXServerClass),
			NULL, NULL,
			(GClassInitFunc) JnaXServerClass_init,
			NULL, NULL,
			sizeof (JnaXServer),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			G_TYPE_OBJECT,
			"JnaXServer", &info, 0);
	}

	return type;
}

GObject* 	
JnaXServer_new			(char* strategy,	
				 char* opt)
{
	JnaXServer* retval;

	g_return_val_if_fail(strategy, NULL);
	g_return_val_if_fail(opt, NULL);
	
	retval=g_object_new(JNA_TYPE_X_SERVER, NULL);
	
	retval->strategy=g_strdup(strategy);
	retval->opt=g_strdup(opt);

	return (GObject*) retval;
}

